
local elements = {}
local function add(arg1)
    elements[#elements+1] = arg1
	arg1:Hide()
end

local L = WeekKeys.L
local res = {}
local stats = {}
-- 6 -> 21

local function calculate()
	table.wipe(res)
	res.ITEM_MOD_CRIT_RATING_SHORT = 0
	res.ITEM_MOD_HASTE_RATING_SHORT = 0
	res.ITEM_MOD_VERSATILITY = 0
	res.ITEM_MOD_MASTERY_RATING_SHORT = 0
	for i=8,23 do 
		if elements[i].link then
			GetItemStats(elements[i].link,stats)
			for a,b in pairs(stats) do
				res[a] = res[a] or 0
				res[a] = res[a] + b
			end
			table.wipe(stats)
		end
	end
	elements[2]:SetData(res["ITEM_MOD_CRIT_RATING_SHORT"],res["ITEM_MOD_CRIT_RATING_SHORT"]/35)
	elements[3]:SetData(res["ITEM_MOD_HASTE_RATING_SHORT"],res["ITEM_MOD_HASTE_RATING_SHORT"]/33)
	elements[4]:SetData(res["ITEM_MOD_VERSATILITY"],res["ITEM_MOD_VERSATILITY"]/40)
	elements[5]:SetData(res["ITEM_MOD_MASTERY_RATING_SHORT"],0)
end
WeekKeys.AddInit(
function()
	local scrframe = CreateFrame('Frame',nil,WeekKeys.WeekFrame.ScrollFrame)
    scrframe:SetFrameStrata("BACKGROUND")
    scrframe:SetSize(480,5)
    WeekKeys.WeekFrame.ScrollFrame:SetScrollChild(scrframe)
    scrframe:SetScript("OnShow",function()
		WeekKeys.WeekFrame.ScrollFrame:ClearAllPoints()
        WeekKeys.WeekFrame.ScrollFrame:SetPoint("TOPLEFT", WeekKeys.WeekFrame, "TOPLEFT", 4, -110);
        WeekKeys.WeekFrame.ScrollFrame:SetPoint("BOTTOMRIGHT",  WeekKeys.WeekFrame, "BOTTOMRIGHT", -5, 5);
    
    end)
    scrframe:SetScript("OnHide",function()
   
    end)
	add(scrframe)
	
	local crit = WeekKeys.WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
    crit:SetPoint("TOPLEFT", 20,-30)
    crit:SetText(STAT_CRITICAL_STRIKE)
	crit.SetData = function(self,val,perc) self:SetFormattedText("%s :|cffffffff %d (+%.2f%%) ",STAT_CRITICAL_STRIKE,val or 0,perc or 0.00)end
    add(crit)
	
	local haste = WeekKeys.WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
    haste:SetPoint("TOPLEFT", 20,-50)
    haste:SetText(STAT_HASTE)
	haste.SetData = function(self,val,perc) self:SetFormattedText("%s :|cffffffff %d (+%.2f%%)",STAT_HASTE,val or 0,perc or 0.00)end
    add(haste)
	
	local versa = WeekKeys.WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
    versa:SetPoint("TOPLEFT", 20,-70)
    versa:SetText(STAT_VERSATILITY)
	versa.SetData = function(self,val,perc) self:SetFormattedText("%s :|cffffffff %d (+%.2f%%)",STAT_VERSATILITY,val or 0,perc or 0.00)end
    add(versa)
	
	local mastery = WeekKeys.WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
    mastery:SetPoint("TOPLEFT", 20,-90)
    mastery:SetText(STAT_MASTERY)
	mastery.SetData = function(self,val,perc) self:SetFormattedText("%s :|cffffffff %d (+?.??%%)",STAT_MASTERY,val or 0)end
    add(mastery)
	
	LootFinder:Find()
	
	local icons = {133070,133292,135061,133771,132751,132616,132939,132511,134584,132535,135317,134959,801523,801523,133441,133441}
	local slots = {0,1,2,3,4,5,6,7,8,9,10,11,12,12,13,13}
	C_Timer.After(1,function()
		for a,b in pairs(icons) do
			--C_Timer.After(a,function()
			local btn = WeekKeys.UI.Button(nil,scrframe)
			btn:SetSize(30,30)
			btn.texture:SetTexture(b)
			btn:SetPoint("TOPLEFT",10,30-30*a)
			add(btn)
			local _, _, classID = UnitClass("player")
			btn:SetScript("OnEnter",function(self)
				if not self.link then return end
				GameTooltip:Hide();
				GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
				GameTooltip:SetHyperlink(self.link,1,1,1)
				GameTooltip:Show()
			end)
			btn:SetScript("OnLeave",function(self)
				GameTooltip:Hide();
			end)
			LootFinder.class = classID
			LootFinder.spec = LootFinder.class_spec[classID][GetSpecialization()]
			LootFinder.slot = slots[a]
			
			LootFinder:Find()
			--[2]
		--	LootFinder.LootList
			local pattern = "5:7214:6652:1501:5868:6646"
			
			for c,d in pairs(LootFinder.LootList) do
				local linkstr = d[2]:gsub("%d+:3524:%d+:%d+:%d+:",pattern)
				local _,_,_,_,_,_,_,_,_,iconid,_,_,subtypeID = GetItemInfo(d[2])
			--	if subtypeID ~= 5 then
					local itembtn = WeekKeys.UI.Button(nil,scrframe)
					itembtn:SetSize(30,30)
					itembtn:SetPoint("TOPLEFT",40+30*c,30-30*a)
					itembtn.texture:SetTexture(iconid)
					itembtn.itemstr = linkstr
					itembtn.iconid = iconid
					itembtn:SetID(7+a)
					itembtn:SetScript("OnClick",function(self) 
						local myid = self:GetID()
						elements[myid].texture:SetTexture(self.iconid)
						elements[myid].link = self.itemstr
						calculate()
					end)
					
					itembtn:SetScript("OnEnter",function(self)
						GameTooltip:Hide();
						GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
						GameTooltip:SetHyperlink(self.itemstr,1,1,1)
						GameTooltip:Show()
					end)
					itembtn:SetScript("OnLeave",function(self)
						GameTooltip:Hide();
					end)
			--	end
			end
		
			--[[
			btn:SetScript("OnClick",function() 
				local a1,a2 = math.random(1000),math.random(100)
				local b1,b2 = math.random(1000),math.random(100)
				local c1,c2 = math.random(1000),math.random(100)
				local d1,d2 = math.random(1000),math.random(100)
				crit:SetData(a1,a2)
				haste:SetData(b1,b2)
				versa:SetData(c1,c2)
				mastery:SetData(d1,d2)
			end)--]]
			--end)
		end
	end)
	local issbtn = WeekKeys.UI.Button(nil,WeekKeys.WeekFrame,true)
	issbtn:SetSize(100,30)
	issbtn:SetPoint("TOPLEFT",350,-25)
	issbtn:SetText(L["info"])
	issbtn:SetScript("OnEnter",function(self)
		GameTooltip:Hide();
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
		GameTooltip:SetWidth(200)
		GameTooltip:AddLine(L["info tooltip"],1,1,1)
		GameTooltip:Show()
	end)
	issbtn:SetScript("OnLeave",function(self)
		GameTooltip:Hide();
	end)
	add(issbtn)


	local errbtn = WeekKeys.UI.Button(nil,WeekKeys.WeekFrame,true)
	errbtn:SetSize(100,30)
	errbtn:SetPoint("TOPLEFT",350,-60)
	errbtn:SetText(L["issues"])
	errbtn:SetScript("OnEnter",function(self)
		GameTooltip:Hide();
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
		GameTooltip:SetWidth(200)
		GameTooltip:AddLine(L["issues tooltip"],1,1,1)
		GameTooltip:Show()
	end)
	errbtn:SetScript("OnLeave",function(self)
		GameTooltip:Hide();
	end)
	add(errbtn)
	--CharacterShirtSlotIconTexture

--local strr = LootFinder.LootList[self:GetID()][2]:gsub("%d+:3524:%d+:%d+:%d+:",pattern)
--DevTools_Dump(GetItemStats(strr))
--GetCombatRatingBonus(CR_HASTE_RANGED)


    WeekKeys.AddButton(DRESSUP_FRAME,elements)
end)